<%@ Page Language="C#" Debug="true" %>

<%@ Import Namespace="System.Drawing.Imaging" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Net" %>
<%@ Import Namespace="System.Net.Security" %>
<%@ Import Namespace="System.Security.Cryptography.X509Certificates" %>
<%@ Import namespace="com.swivelsecure.pinsafe" %>

<script runat="server">

    protected void Page_Load(object sender, EventArgs e) {
        // Load settings
        PINsafeClient client = new PINsafeClient();
		// Get the ID of the image to retrieve.
		string sessionId = Request["sessionid"];
		string username = Request["username"];

        string requestType = Request["type"];
        int statusCode;
        System.Drawing.Image img = "message".Equals(requestType)
                        ? client.GetMessage(sessionId, username, out statusCode) : client.GetImage(sessionId, username, out statusCode);

        // Request image
			if (statusCode != (int)HttpStatusCode.OK)
			{
				Response.StatusCode = statusCode;
			}
			else
			{
				Response.ContentType = "image/gif";
				StringBuilder disposition = new StringBuilder("inline; filename=turing.gif");
				Response.AddHeader("Content-Disposition", disposition.ToString());
				if (img != null)
				{
					img.Save(Response.OutputStream, ImageFormat.Gif);
				}
			}

        // Try and prevent caching
        Response.CacheControl = "private";
        Response.ExpiresAbsolute = new DateTime(1970, 1, 1);
        Response.AddHeader("Pragma", "no-cache");

        // Done
        Response.End();
    }

</script>
